<?php

namespace App\Nova\Filters;

use Carbon\Carbon;
use Illuminate\Http\Request;
use Laravel\Nova\Filters\Filter;

class SubscriptionStatusFilter extends Filter
{
    /**
     * The filter's component.
     *
     * @var string
     */
    public $component = 'select-filter';

    public function name()
    {
        return 'Подписка';
    }

    public function authorize(Request $request)
    {
        return true;
    }

    /**
     * Apply the filter to the given query.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \Illuminate\Database\Eloquent\Builder  $query
     * @param  mixed  $value
     * @return \Illuminate\Database\Eloquent\Builder
     */
    public function apply(Request $request, $query, $value)
    {
        if ($value === 'active') {
            // Фильтруем записи, где у пользователя есть активная подписка
            $query->whereHas('user.subscription', function ($q) {
                $q->where('ends_at', '>', Carbon::now());
            });
        } elseif ($value === 'inactive') {
            // Фильтруем записи, где у пользователя нет активной подписки
            $query->where(function ($q) {
                $q->whereDoesntHave('user.subscription')
                  ->orWhere(function ($q) {
                      $q->whereHas('user.subscription', function ($q) {
                          $q->where('ends_at', '<=', Carbon::now());
                      })->whereDoesntHave('user.subscription', function ($q) {
                          $q->where('ends_at', '>', Carbon::now());
                      });
                  });
            });
        }

        return $query;
    }

    /**
     * Get the filter's available options.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return array
     */
    public function options(Request $request)
    {
        return [
            'Активна' => 'active',
            'Неактивна' => 'inactive',
        ];
    }
}
